using System;

namespace DShowNET
{
	/// <summary>
	/// Summary description for WmError.
	/// </summary>
	public class WmError
	{
		public static void ThrowExceptionForWM(int hr)
		{
			if (hr == 0) return;
			throw new Exception(Enum.GetName(typeof(Errors), hr).ToString());
		}

		private const int MMSYSERR_BASE	=	 0;
		private const int WAVERR_BASE   =	32;
		private const int MIDIERR_BASE  =	64;
		private const int TIMERR_BASE   =	96;
		private const int JOYERR_BASE   =  160;
		private const int MCIERR_BASE   =  256;
		private const int MIXERR_BASE   = 1024;

		enum Errors
		{
			MMSYSERR_NOERROR      = 0,                    /* no error */
			MMSYSERR_ERROR        = (MMSYSERR_BASE + 1),  /* unspecified error */
			MMSYSERR_BADDEVICEID  = (MMSYSERR_BASE + 2),  /* device ID out of range */
			MMSYSERR_NOTENABLED   = (MMSYSERR_BASE + 3),  /* driver failed enable */
			MMSYSERR_ALLOCATED    = (MMSYSERR_BASE + 4),  /* device already allocated */
			MMSYSERR_INVALHANDLE  = (MMSYSERR_BASE + 5),  /* device handle is invalid */
			MMSYSERR_NODRIVER     = (MMSYSERR_BASE + 6),  /* no device driver present */
			MMSYSERR_NOMEM        = (MMSYSERR_BASE + 7),  /* memory allocation error */
			MMSYSERR_NOTSUPPORTED = (MMSYSERR_BASE + 8),  /* function isn't supported */
			MMSYSERR_BADERRNUM    = (MMSYSERR_BASE + 9),  /* error value out of range */
			MMSYSERR_INVALFLAG    = (MMSYSERR_BASE + 10), /* invalid flag passed */
			MMSYSERR_INVALPARAM   = (MMSYSERR_BASE + 11), /* invalid parameter passed */
			MMSYSERR_HANDLEBUSY   = (MMSYSERR_BASE + 12), /* handle being used simultaneously on another thread (eg callback) */
			MMSYSERR_INVALIDALIAS = (MMSYSERR_BASE + 13), /* specified alias not found */
			MMSYSERR_BADDB        = (MMSYSERR_BASE + 14), /* bad registry database */
			MMSYSERR_KEYNOTFOUND  = (MMSYSERR_BASE + 15), /* registry key not found */
			MMSYSERR_READERROR    = (MMSYSERR_BASE + 16), /* registry read error */
			MMSYSERR_WRITEERROR   = (MMSYSERR_BASE + 17), /* registry write error */
			MMSYSERR_DELETEERROR  = (MMSYSERR_BASE + 18), /* registry delete error */
			MMSYSERR_VALNOTFOUND  = (MMSYSERR_BASE + 19), /* registry value not found */
			MMSYSERR_NODRIVERCB   = (MMSYSERR_BASE + 20), /* driver does not call DriverCallback */
			MMSYSERR_MOREDATA     = (MMSYSERR_BASE + 21), /* more data to be returned */
			MMSYSERR_LASTERROR    = (MMSYSERR_BASE + 21), /* last error in range */

			MIXERR_INVALLINE      = (MIXERR_BASE + 0),
			MIXERR_INVALCONTROL   = (MIXERR_BASE + 1),
			MIXERR_INVALVALUE     = (MIXERR_BASE + 2),
			MIXERR_LASTERROR      = (MIXERR_BASE + 2),
		}
	}
}
